//-----------------------------------
// Copyright Pierric Gimmig 2013-2017
//-----------------------------------

#include "OrbitDll.h"

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <iostream>
#include <fstream>
#include "OrbitCore\OrbitLib.h"
#include "OrbitCore\TcpClient.h"
#include "OrbitCore\PrintVar.h"

using namespace std;

extern "C"
{
    __declspec(dllexport) void __cdecl OrbitInit( void* a_Host )
    {
        PRINT_FUNC;
        std::string host = (char*)a_Host;
        Orbit::Init( host );
    }

    __declspec( dllexport ) void __cdecl OrbitInitRemote( void* a_Host )
    {
        PRINT_FUNC;
        std::string host = (char*)a_Host;
        Orbit::InitRemote( host );
    }

    __declspec( dllexport ) bool __cdecl OrbitIsConnected()
    {
        return GTcpClient && GTcpClient->IsValid();
    }

    __declspec( dllexport ) bool __cdecl OrbitStart()
    {
        if( OrbitIsConnected() )
        {
            Orbit::Start();
            return true;
        }

        return false;
    }

    __declspec( dllexport ) bool __cdecl OrbitStop()
    {
        if( OrbitIsConnected() )
        {
            Orbit::Stop();
            return true;
        }

        return false;
    }
}

BOOL WINAPI DllMain( _In_ HINSTANCE hinstDLL
                   , _In_ DWORD fdwReason
                   , _In_ LPVOID lpvReserved )
{
    switch (fdwReason)
    {
    case DLL_PROCESS_ATTACH:
        //OutputDebugString(L"DLL_PROCESS_ATTACH\n");
        break;

    case DLL_PROCESS_DETACH:
        //OutputDebugString(L"DLL_PROCESS_DETACH\n");
        break;

    case DLL_THREAD_ATTACH:
        //OutputDebugString(L"DLL_THREAD_ATTACH\n");
        break;

    case DLL_THREAD_DETACH:
        //OutputDebugString(L"DLL_THREAD_DETACH\n");
        break;
    default:
        //OutputDebugString(L"DLL_UNKNOWN\n");
        break;
    }

    return TRUE;
}
